SuperPotion = {}

function SuperPotion:Initialize(obj)
	self.Object = obj
	
	self.Width = 1
	self.Height = 1
	
	self.DrawOrder = DrawOrder.Normal
	
	self.AlwaysDraw = true
	self.CanMove = false
	self.IsInvincible = true
	self.IsDead = false
	self.IsSolid = false
	self.HasSpawned = false
	
	self.Name = "Spr Potion"
	
	self.Font = Font.Create(Game.AbsolutePath .. "Content/Fonts/Font-large.pcx")
end

function SuperPotion:OnSpawn(arg)
	self.Location = Point.Create(arg.X, arg.Y)
	self.IsOwned = false
end

function SuperPotion:OnTake(arg)
	self.Owner = arg.Owner
	self.IsOwned = true
end

function SuperPotion:OnUse(arg)
	local hp = self.Owner.Skills.HP
	
	if hp.AdditionalXp < 0 then
		hp.AdditionalXp = -math.ceil(-(hp.AdditionalXp / 2))
	else
		Messenger:Add("Why'd you just waste a potion?!")
	end
	
	if self.Owner.OnUsedUpItem then
		self.Owner:OnUsedUpItem({ Item = self })
	end
end

function SuperPotion:Update()
	if self.IsOwned then
		self.Location = self.Owner.Location
	end
end

function SuperPotion:Draw(buffer, camera)
	if not self.IsOwned then
		GameObject.Drawing.DrawRectangle(buffer, self, camera, Graphics.MakeColor(200, 100, 200), Graphics.MakeColor(150, 50, 150), "SP")
	end
end
